io.vertx.rxjava.core.file

## Class AsyncFile

- java.lang.Object
- - io.vertx.rxjava.core.file.AsyncFile

- All Implemented Interfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public class AsyncFile
      extends Object
      implements ReadStream<Buffer>, WriteStream<Buffer>

  Represents a file on the file-system which can be read from, or written to asynchronously.

  This class also implements `ReadStream` and `WriteStream`. This allows the data to be pumped to and from other streams, e.g. an `HttpClientRequest` instance, using the `Pump` class

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static io.vertx.lang.rx.TypeArg<AsyncFile>` | `__TYPE_ARG`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsyncFile(AsyncFile delegate)`
    `AsyncFile(Object delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the file.
    `void` | `close(Handler<AsyncResult<Void>> handler)` Close the file.
    `Observable<Void>` | `closeObservable()` Deprecated. use `rxClose()` instead
    `AsyncFile` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Close the file, see `close()`.
    `void` | `end(Buffer data)` Same as `end(io.vertx.rxjava.core.buffer.Buffer)` but writes some data to the stream before ending.
    `void` | `end(Buffer data, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `void` | `end(Handler<AsyncResult<Void>> handler)` Close the file, see `close()`.
    `AsyncFile` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `Observable<Void>` | `endObservable()` Deprecated. use `rxEnd(io.vertx.rxjava.core.buffer.Buffer)` instead
    `Observable<Void>` | `endObservable(Buffer data)` Deprecated. use `rxEnd(io.vertx.rxjava.core.buffer.Buffer)` instead
    `boolean` | `equals(Object o)`
    `AsyncFile` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `AsyncFile` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `AsyncFile` | `flush()` Flush any writes made to this file to underlying persistent storage.
    `AsyncFile` | `flush(Handler<AsyncResult<Void>> handler)` Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
    `Observable<Void>` | `flushObservable()` Deprecated. use `rxFlush()` instead
    `AsyncFile` | `getDelegate()`
    `long` | `getWritePos()`
    `AsyncFile` | `handler(Handler<Buffer> handler)` Set a data handler.
    `int` | `hashCode()`
    `static AsyncFile` | `newInstance(AsyncFile arg)`
    `AsyncFile` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Pipe<Buffer>` | `pipe()` Pause this stream and return a to transfer the elements of this stream to a destination .
    `void` | `pipeTo(WriteStream<Buffer> dst)` Like `ReadStream.pipeTo(io.vertx.rxjava.core.streams.WriteStream<T>)` but with no completion handler.
    `void` | `pipeTo(WriteStream<Buffer> dst, Handler<AsyncResult<Void>> handler)` Pipe this `ReadStream` to the `WriteStream`.
    `Observable<Void>` | `pipeToObservable(WriteStream<Buffer> dst)` Deprecated. use `rxPipeTo(io.vertx.rxjava.core.streams.WriteStream<io.vertx.rxjava.core.buffer.Buffer>)` instead
    `AsyncFile` | `read(Buffer buffer, int offset, long position, int length, Handler<AsyncResult<Buffer>> handler)` Reads `length` bytes of data from the file at position `position` in the file, asynchronously.
    `Observable<Buffer>` | `readObservable(Buffer buffer, int offset, long position, int length)` Deprecated. use `rxRead(io.vertx.rxjava.core.buffer.Buffer, int, long, int)` instead
    `AsyncFile` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `Single<Void>` | `rxClose()` Close the file.
    `Single<Void>` | `rxEnd()` Close the file, see `close()`.
    `Single<Void>` | `rxEnd(Buffer data)` Same as but with an `handler` called when the operation completes
    `Single<Void>` | `rxFlush()` Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
    `Single<Void>` | `rxPipeTo(WriteStream<Buffer> dst)` Pipe this `ReadStream` to the `WriteStream`.
    `Single<Buffer>` | `rxRead(Buffer buffer, int offset, long position, int length)` Reads `length` bytes of data from the file at position `position` in the file, asynchronously.
    `Single<Void>` | `rxWrite(Buffer data)` Same as `write(io.vertx.rxjava.core.buffer.Buffer)` but with an `handler` called when the operation completes
    `Single<Void>` | `rxWrite(Buffer buffer, long position)` Write a `Buffer` to the file at position `position` in the file, asynchronously.
    `AsyncFile` | `setReadBufferSize(int readBufferSize)` Sets the buffer size that will be used to read the data from the file.
    `AsyncFile` | `setReadLength(long readLength)` Sets the number of bytes that will be read when using the file as a `ReadStream`.
    `AsyncFile` | `setReadPos(long readPos)` Sets the position from which data will be read from when using the file as a `ReadStream`.
    `AsyncFile` | `setWritePos(long writePos)` Sets the position from which data will be written when using the file as a `WriteStream`.
    `AsyncFile` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `Observable<Buffer>` | `toObservable()`
    `String` | `toString()`
    `io.vertx.rx.java.WriteStreamSubscriber<Buffer>` | `toSubscriber()`
    `AsyncFile` | `write(Buffer data)` Write some data to the stream.
    `AsyncFile` | `write(Buffer data, Handler<AsyncResult<Void>> handler)` Same as `write(io.vertx.rxjava.core.buffer.Buffer)` but with an `handler` called when the operation completes
    `AsyncFile` | `write(Buffer buffer, long position, Handler<AsyncResult<Void>> handler)` Write a `Buffer` to the file at position `position` in the file, asynchronously.
    `Observable<Void>` | `writeObservable(Buffer data)` Deprecated. use `rxWrite(io.vertx.rxjava.core.buffer.Buffer)` instead
    `Observable<Void>` | `writeObservable(Buffer buffer, long position)` Deprecated. use `rxWrite(io.vertx.rxjava.core.buffer.Buffer)` instead
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.ReadStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.WriteStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.StreamBase

      `newInstance`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<AsyncFile> __TYPE_ARG

  - ### Constructor Detail

    - #### AsyncFile

          public AsyncFile(AsyncFile delegate)

    - #### AsyncFile

          public AsyncFile(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public AsyncFile getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### toSubscriber

          public io.vertx.rx.java.WriteStreamSubscriber<Buffer> toSubscriber()

    - #### end

          public void end(Buffer data)

      Same as `end(io.vertx.rxjava.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write

    - #### end

          public void end(Buffer data,
                          Handler<AsyncResult<Void>> handler)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
        `handler` -

    - #### endObservable

          @Deprecated
          public Observable<Void> endObservable(Buffer data)

      Deprecated. use `rxEnd(io.vertx.rxjava.core.buffer.Buffer)` instead
      Same as but with an `handler` called when the operation completes
      Parameters:
        `data` -
      Returns:

    - #### rxEnd

          public Single<Void> rxEnd(Buffer data)

      Same as but with an `handler` called when the operation completes
      Parameters:
        `data` -
      Returns:

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        true if write queue is full

    - #### pipe

          public Pipe<Buffer> pipe()

      Pause this stream and return a to transfer the elements of this stream to a destination .

      The stream will be resumed when the pipe will be wired to a `WriteStream`.
      Specified by:
        `pipe` in interface `ReadStream<Buffer>`
      Returns:
        a pipe

    - #### pipeTo

          public void pipeTo(WriteStream<Buffer> dst)

      Like `ReadStream.pipeTo(io.vertx.rxjava.core.streams.WriteStream<T>)` but with no completion handler.
      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` -

    - #### pipeTo

          public void pipeTo(WriteStream<Buffer> dst,
                             Handler<AsyncResult<Void>> handler)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Once this stream has ended or failed, the write stream will be ended and the `handler` will be called with the result.

      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
        `handler` -

    - #### pipeToObservable

          @Deprecated
          public Observable<Void> pipeToObservable(WriteStream<Buffer> dst)

      Deprecated. use `rxPipeTo(io.vertx.rxjava.core.streams.WriteStream<io.vertx.rxjava.core.buffer.Buffer>)` instead
      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Once this stream has ended or failed, the write stream will be ended and the `handler` will be called with the result.

      Parameters:
        `dst` - the destination write stream
      Returns:

    - #### rxPipeTo

          public Single<Void> rxPipeTo(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Once this stream has ended or failed, the write stream will be ended and the `handler` will be called with the result.

      Parameters:
        `dst` - the destination write stream
      Returns:

    - #### handler

          public AsyncFile handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public AsyncFile pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public AsyncFile resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public AsyncFile endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public AsyncFile write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public AsyncFile write(Buffer data,
                                 Handler<AsyncResult<Void>> handler)

      Same as `write(io.vertx.rxjava.core.buffer.Buffer)` but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
        `handler` -
      Returns:

    - #### writeObservable

          @Deprecated
          public Observable<Void> writeObservable(Buffer data)

      Deprecated. use `rxWrite(io.vertx.rxjava.core.buffer.Buffer)` instead
      Same as `write(io.vertx.rxjava.core.buffer.Buffer)` but with an `handler` called when the operation completes
      Parameters:
        `data` -
      Returns:

    - #### rxWrite

          public Single<Void> rxWrite(Buffer data)

      Same as `write(io.vertx.rxjava.core.buffer.Buffer)` but with an `handler` called when the operation completes
      Parameters:
        `data` -
      Returns:

    - #### setWriteQueueMaxSize

          public AsyncFile setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, the number of `Message` for a `MessageProducer`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public AsyncFile drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pump` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### exceptionHandler

          public AsyncFile exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          public AsyncFile fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### end

          public void end()

      Close the file, see `close()`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### end

          public void end(Handler<AsyncResult<Void>> handler)

      Close the file, see `close()`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` -

    - #### endObservable

          @Deprecated
          public Observable<Void> endObservable()

      Deprecated. use `rxEnd(io.vertx.rxjava.core.buffer.Buffer)` instead
      Close the file, see `close()`.
      Returns:

    - #### rxEnd

          public Single<Void> rxEnd()

      Close the file, see `close()`.
      Returns:

    - #### close

          public void close()

      Close the file. The actual close happens asynchronously.

    - #### close

          public void close(Handler<AsyncResult<Void>> handler)

      Close the file. The actual close happens asynchronously. The handler will be called when the close is complete, or an error occurs.
      Parameters:
        `handler` - the handler

    - #### closeObservable

          @Deprecated
          public Observable<Void> closeObservable()

      Deprecated. use `rxClose()` instead
      Close the file. The actual close happens asynchronously. The handler will be called when the close is complete, or an error occurs.
      Returns:

    - #### rxClose

          public Single<Void> rxClose()

      Close the file. The actual close happens asynchronously. The handler will be called when the close is complete, or an error occurs.
      Returns:

    - #### write

          public AsyncFile write(Buffer buffer,
                                 long position,
                                 Handler<AsyncResult<Void>> handler)

      Write a `Buffer` to the file at position `position` in the file, asynchronously.

      If `position` lies outside of the current size of the file, the file will be enlarged to encompass it.

      When multiple writes are invoked on the same file there are no guarantees as to order in which those writes actually occur

      The handler will be called when the write is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to write
        `position` - the position in the file to write it at
        `handler` - the handler to call when the write is complete
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeObservable

          @Deprecated
          public Observable<Void> writeObservable(Buffer buffer,
                                                              long position)

      Deprecated. use `rxWrite(io.vertx.rxjava.core.buffer.Buffer)` instead
      Write a `Buffer` to the file at position `position` in the file, asynchronously.

      If `position` lies outside of the current size of the file, the file will be enlarged to encompass it.

      When multiple writes are invoked on the same file there are no guarantees as to order in which those writes actually occur

      The handler will be called when the write is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to write
        `position` - the position in the file to write it at
      Returns:
        a reference to this, so the API can be used fluently

    - #### rxWrite

          public Single<Void> rxWrite(Buffer buffer,
                                      long position)

      Write a `Buffer` to the file at position `position` in the file, asynchronously.

      If `position` lies outside of the current size of the file, the file will be enlarged to encompass it.

      When multiple writes are invoked on the same file there are no guarantees as to order in which those writes actually occur

      The handler will be called when the write is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to write
        `position` - the position in the file to write it at
      Returns:
        a reference to this, so the API can be used fluently

    - #### read

          public AsyncFile read(Buffer buffer,
                                int offset,
                                long position,
                                int length,
                                Handler<AsyncResult<Buffer>> handler)

      Reads `length` bytes of data from the file at position `position` in the file, asynchronously.

      The read data will be written into the specified `Buffer buffer` at position `offset`.

      If data is read past the end of the file then zero bytes will be read.

      When multiple reads are invoked on the same file there are no guarantees as to order in which those reads actually occur.

      The handler will be called when the close is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to read into
        `offset` - the offset into the buffer where the data will be read
        `position` - the position in the file where to start reading
        `length` - the number of bytes to read
        `handler` - the handler to call when the write is complete
      Returns:
        a reference to this, so the API can be used fluently

    - #### readObservable

          @Deprecated
          public Observable<Buffer> readObservable(Buffer buffer,
                                                               int offset,
                                                               long position,
                                                               int length)

      Deprecated. use `rxRead(io.vertx.rxjava.core.buffer.Buffer, int, long, int)` instead
      Reads `length` bytes of data from the file at position `position` in the file, asynchronously.

      The read data will be written into the specified `Buffer buffer` at position `offset`.

      If data is read past the end of the file then zero bytes will be read.

      When multiple reads are invoked on the same file there are no guarantees as to order in which those reads actually occur.

      The handler will be called when the close is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to read into
        `offset` - the offset into the buffer where the data will be read
        `position` - the position in the file where to start reading
        `length` - the number of bytes to read
      Returns:
        a reference to this, so the API can be used fluently

    - #### rxRead

          public Single<Buffer> rxRead(Buffer buffer,
                                       int offset,
                                       long position,
                                       int length)

      Reads `length` bytes of data from the file at position `position` in the file, asynchronously.

      The read data will be written into the specified `Buffer buffer` at position `offset`.

      If data is read past the end of the file then zero bytes will be read.

      When multiple reads are invoked on the same file there are no guarantees as to order in which those reads actually occur.

      The handler will be called when the close is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to read into
        `offset` - the offset into the buffer where the data will be read
        `position` - the position in the file where to start reading
        `length` - the number of bytes to read
      Returns:
        a reference to this, so the API can be used fluently

    - #### flush

          public AsyncFile flush()

      Flush any writes made to this file to underlying persistent storage.

      If the file was opened with `flush` set to `true` then calling this method will have no effect.

      The actual flush will happen asynchronously.

      Returns:
        a reference to this, so the API can be used fluently

    - #### flush

          public AsyncFile flush(Handler<AsyncResult<Void>> handler)

      Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
      Parameters:
        `handler` -
      Returns:

    - #### flushObservable

          @Deprecated
          public Observable<Void> flushObservable()

      Deprecated. use `rxFlush()` instead
      Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
      Returns:

    - #### rxFlush

          public Single<Void> rxFlush()

      Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
      Returns:

    - #### setReadPos

          public AsyncFile setReadPos(long readPos)

      Sets the position from which data will be read from when using the file as a `ReadStream`.
      Parameters:
        `readPos` - the position in the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### setReadLength

          public AsyncFile setReadLength(long readLength)

      Sets the number of bytes that will be read when using the file as a `ReadStream`.
      Parameters:
        `readLength` - the bytes that will be read from the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWritePos

          public AsyncFile setWritePos(long writePos)

      Sets the position from which data will be written when using the file as a `WriteStream`.
      Parameters:
        `writePos` - the position in the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### getWritePos

          public long getWritePos()

      Returns:
        the current write position the file is at

    - #### setReadBufferSize

          public AsyncFile setReadBufferSize(int readBufferSize)

      Sets the buffer size that will be used to read the data from the file. Changing this value will impact how much the data will be read at a time from the file system.
      Parameters:
        `readBufferSize` - the buffer size
      Returns:
        a reference to this, so the API can be used fluently

    - #### newInstance

          public static AsyncFile newInstance(AsyncFile arg)

Copyright © 2020 Eclipse. All rights reserved.